/*
 * Fachlicher Schlüssel für JPA Entität
 */
package de.ivu.elect.business.entschaedigung.entity;

import de.ivu.elect.jee.faces.Messages;
import java.util.function.Function;

@javax.enterprise.inject.Vetoed
public class EntschaedigungsartTK
implements de.ivu.elect.jee.entity.tk.EntityTK, java.io.Serializable
  {

  private static final long serialVersionUID = 1L;

  private final int hashCode;

    protected final java.lang.String bezeichnung;
    public java.lang.String getBezeichnung(){
      return bezeichnung;
    }
    protected final java.lang.String kriteriumPersonendatenArt;
    public java.lang.String getKriteriumPersonendatenArt(){
      return kriteriumPersonendatenArt;
    }
    protected final java.lang.String template;
    public java.lang.String getTemplate(){
      return template;
    }

  public EntschaedigungsartTK(
java.lang.String bezeichnung
, java.lang.String kriteriumPersonendatenArt
, java.lang.String template
  ) {
    super();


      this.bezeichnung = bezeichnung;
      this.kriteriumPersonendatenArt = kriteriumPersonendatenArt;
      this.template = template;
    
hashCode = calculateHashCode();
  }

  @Override
  public int hashCode(){
    return hashCode;
  }


  protected int calculateHashCode() {
        int result = 1;
    
    
                    result = result + ((bezeichnung == null) ? 0 : bezeichnung.hashCode());
                    result = result + ((kriteriumPersonendatenArt == null) ? 0 : kriteriumPersonendatenArt.hashCode());
                    result = result + ((template == null) ? 0 : template.hashCode());
        
            
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }

    if (obj == null) {
      return false;
    }

    if (hashCode()!=obj.hashCode()) {
      return false;
    }


            
    if (getClass() != obj.getClass()) {
      if (!(obj instanceof EntschaedigungsartTK)) {
        return false;
      }

      if (!obj.getClass().isInstance(this)) {
        return obj.equals(this); // equals-Methode aus speziellerer Klasse verwenden
      }

    }

        EntschaedigungsartTK other = (EntschaedigungsartTK) obj;

                if (bezeichnung == null) {
          if (other.bezeichnung != null) {
            return false;
          }
        } else if (!bezeichnung.equals(other.bezeichnung)) {
          return false;
        }
                if (kriteriumPersonendatenArt == null) {
          if (other.kriteriumPersonendatenArt != null) {
            return false;
          }
        } else if (!kriteriumPersonendatenArt.equals(other.kriteriumPersonendatenArt)) {
          return false;
        }
                if (template == null) {
          if (other.template != null) {
            return false;
          }
        } else if (!template.equals(other.template)) {
          return false;
        }
        
            return true;
    
  }

  protected boolean hatAttribute() {
        return true;
      }

  @Override
  public String getEntityMessageKey() {
    return EntschaedigungsartConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getAllEntityFieldValues() {
    java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

    result.addAll(getEntityFieldValuesForEntity());
    return result;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getEntityFieldValuesForEntity() {
            java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(EntschaedigungsartConstants.MESSAGE_KEY_ENTITY_EINZAHL, EntschaedigungsartConstants.MESSAGE_KEY_BEZEICHNUNG_EINZAHL, bezeichnung));
                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(EntschaedigungsartConstants.MESSAGE_KEY_ENTITY_EINZAHL, EntschaedigungsartConstants.MESSAGE_KEY_KRITERIUM_PERSONENDATEN_ART_EINZAHL, kriteriumPersonendatenArt));
                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(EntschaedigungsartConstants.MESSAGE_KEY_ENTITY_EINZAHL, EntschaedigungsartConstants.MESSAGE_KEY_ENTSCHAEDIGUNGSART_TEMPLATE_EINZAHL, template));
        
        return result;
      }


            @Override
            public String toString() {
            return "EntschaedigungsartTK[" + toStringParameter() + "]";
            }



            protected String toStringParameter() {
            String result = ""

                                        +"bezeichnung="+bezeichnung
                            +", kriteriumPersonendatenArt="+kriteriumPersonendatenArt
                            +", template="+template
                        
            ;
                            return result;
            
            }

  @Override
  public String toStringLokalisiert(Messages messages) {
    return messages.getMessageForMessageKey(getEntityMessageKey()) + " ["
            + toStringLokalisiertFields(messages)
            + "]"
            ;
   }

            protected String toStringLokalisiertFields(Messages messages) {
        return ""
                                      + messages.getMessageForMessageKey(EntschaedigungsartConstants.MESSAGE_KEY_BEZEICHNUNG_EINZAHL) + "=" + bezeichnung
                          + ", " + messages.getMessageForMessageKey(EntschaedigungsartConstants.MESSAGE_KEY_KRITERIUM_PERSONENDATEN_ART_EINZAHL) + "=" + kriteriumPersonendatenArt
                          + ", " + messages.getMessageForMessageKey(EntschaedigungsartConstants.MESSAGE_KEY_ENTSCHAEDIGUNGSART_TEMPLATE_EINZAHL) + "=" + template
                                             ;
      }


            private String toStringLokalisiert(de.ivu.elect.jee.entity.tk.EntityTK entityTK, Messages messages) {
                if (entityTK != null) {
                    return entityTK.toStringLokalisiert(messages);
                }
                return null;
            }

            public static <E extends Entschaedigungsart> java.util.Map<EntschaedigungsartTK, E> mappeEntschaedigungsartNachTK(java.util.Collection<E> entities) {
                return entities.stream().collect(java.util.stream.Collectors.toMap(Entschaedigungsart::getEntschaedigungsartTK, Function.<E>identity(), (u,v)-> v));
                }


                public static Function<Entschaedigungsart, EntschaedigungsartTK> getEntschaedigungsartToTKFunction() {
                return Entschaedigungsart::getEntschaedigungsartTK;
                }

}
